import React, { FunctionComponent } from 'react';
import { TaroDialogProps } from "../../types";
declare const defaultProps: {
    title: string;
    content: string;
    header: string;
    footer: string;
    confirmText: string;
    cancelText: string;
    hideConfirmButton: boolean;
    hideCancelButton: boolean;
    disableConfirmButton: boolean;
    footerDirection: string;
    closeIconPosition: string;
    closeIcon: boolean;
    overlay: boolean;
    overlayStyle: {};
    overlayClassName: string;
    zIndex: number;
    beforeCancel: () => boolean;
    beforeClose: () => boolean;
    onCancel: () => void;
    onClose: () => void;
    onConfirm: () => void;
    onOverlayClick: () => boolean;
    visible: boolean;
    close: string;
    onClick: () => void;
    className?: string | undefined;
    id?: string | undefined;
    children?: React.ReactNode;
    style?: React.CSSProperties | undefined;
    duration: number;
    closeOnOverlayClick: boolean;
    lockScroll: boolean;
    afterShow: () => void;
    afterClose: () => void;
};
export declare const BaseDialog: FunctionComponent<Partial<TaroDialogProps>> & {
    open: typeof open;
    close: typeof close;
};
export declare function open(selector: string, options: Partial<typeof defaultProps>): void;
export declare function close(selector: string): void;
export {};
