import { BaseProps } from '../../base/props';
export interface BaseAudio extends BaseProps {
    /**
    * 语音资源链接
    */
    src: string
    /**
    * 是否静音
    */
    muted: boolean
    /**
    * 是否自动播放
    */
    autoPlay: boolean
    /**
    * 是否循环播放
    */
    loop: boolean
    /**
    * 是否预加载语音
    */
    preload: string
    /**
    * 展示形式，可选值：controls 控制面板 progress 进度条 icon 图标 none 自定义
    */
    type: string
    onBack: (event: any) => void;
    /**
    * 语音快进回调,type=progress时生效
    */
    onForward: (event: any) => void
    /**
    * 暂停回调
    */
    onPause: (event: any) => void
    onEnd: (event: any) => void;
    /**
    * 静音回调
    */
    onMute: (event: any) => void
    /**
    * 可以播放媒体时触发
    */
    onCanPlay: (event: any) => void
}
