import { BaseProps } from '../../base/props';
import { SimpleValue } from '../../base/atoms';
export interface ElevatorItem {
    name: string;
    id: SimpleValue;
    [key: string]: SimpleValue;
}
export type ElevatorFloorKey = string;
export type ElevatorList = {
    list: Array<ElevatorItem>;
    [key: string]: SimpleValue | Array<ElevatorItem>;
};
export type ElevatorMode = 'horizontal' | 'vertical';
export interface BaseElevator extends BaseProps {
    /**
    * 默认选中的值，受控
    */
    defaultValue?: ElevatorItem
    /**
    * 当前选中的值
    */
    value?: ElevatorItem
    /**
    * 电梯结构展示模式
    */
    mode: ElevatorMode
    /**
    * 电梯区域的高度
    */
    height: SimpleValue
    /**
    * 索引 key 值
    */
    floorKey: ElevatorFloorKey
    /**
    * 索引列表
    */
    list: ElevatorList[]
    /**
    * 索引是否吸顶
    */
    sticky: boolean
    /**
    * 右侧锚点的上下间距
    */
    spaceHeight: number
    titleHeight: number;
    /**
    * 展示右侧导航
    */
    showKeys: boolean
    /**
    * 点击内容
    */
    onItemClick: (key: string, item: ElevatorItem) => void
    /**
    * 点击索引
    */
    onIndexClick: (key: string) => void
}
