import { BaseProps } from '../../base/props';
import { SimpleValue } from '../../base/atoms';
export type BaseLottie<LOTTIE_LIBRARY> = BaseProps & LOTTIE_LIBRARY & {
    /**
    * 包含导出动画数据的 JSON 对象
    */
    source: NonNullable<unknown>
    /**
    * loading图标和文字的排列方式
    */
    loop: SimpleValue | boolean
    /**
    * 动画将在加载后立即播放
    */
    autoPlay: boolean
    /**
    * 第一个值是初始帧，第二个值是最终帧。如果设置了该值，动画将从此时间位置开始
    */
    initialSegment: [number, number]
    /**
    * 播放速度
    */
    speed: number
};
